

LOAD_MOVIE:
  OPEN 6,8,6,AUDIOTRACK$+",S,R"
  OPEN 4,8,4,FRAMEFILE$+",S,R"

  GOSUB GET.VIDEO.HEADER
  GOSUB SET.VIDEO.ATTRIBUTES
  GOSUB SET.AUDIOCODE
  GOSUB CALCULATE.SPRITES

  GOTO SET.SPRITECODE
## RETURN
## TAIL CALL OPTIMIZATION


PLAY_MOVIE:
  IF BPP = 4 THEN SCR.NUM = $80
  IF BPP = 8 THEN SCR.NUM = 3
  SCREEN SCR.NUM
  IF SCR.NUM = 3 THEN COLOR 1,0:CLS
  IF SCR.NUM = $80 THEN RECT 0,0,319,239, $10

  DBLED = FRAME_HINT$ = "D" OR (FRAMEHEIGHT <= (FRAMEWIDTH/2))
  IF FULL_SCREEN THEN X.ORG=0:Y.ORG=0:GOSUB SET.FULLSCREEN
  GOSUB PAL2BLACK
  GOSUB SetUpSprites
  ZEROALL:
## Initially zero out the Sprite RAM
  IF BPP=4 THEN PLAY_the_Movie
  BANK VIDPLAYER_BANK
  IF BPP=8 THEN SYS $A003


PLAY_the_Movie:
   IF DBLED THEN GOSUB HIDETEXT
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R15L, 1
   BANK VIDPLAYER_BANK
   SYS $A000
   SYS CLRCHN
   CLOSE 4
   CLOSE 6
RETURN

CLEANUPMOVIE:
   FOR I = 1 TO (NUMSPRITES*2):SPRITE I,0:NEXT
   SCREEN 0
   COLOR 1,6:CLS
   GOSUB SHOWTEXT
   GOSUB SETDEFPAL
RETURN

SET.FULLSCREEN:
  X.SCALE = FN H.FULL_SCALE(FRAMEWIDTH)
  Y.SCALE = FN V.FULL_SCALE(FRAMEHEIGHT)

  TALLVIDEO = FRAME_HINT$="T" OR FRAMEWIDTH <= (FRAMEHEIGHT/1.5)

  IF TALLVIDEO THEN X.SCALE = Y.SCALE-1:X.ORG = ((640 * (X.SCALE/128)) - FRAMEWIDTH)/2:X.ORG = FN ROUND(X.ORG)

  POKE VERA.HSCALE, X.SCALE
  POKE VERA.VSCALE, Y.SCALE
RETURN

SET.AUDIOCODE:
  CHANNEL = 6
  GOSUB GETFILESIZE
  ASIZE = FILESIZE / NUMFRAMES
  ASIZE = FN ROUND(ASIZE)
  IF MESSAGES_OFF THEN SKIP_AUDIOINFO
  PRINT
  PRINT "{WHT} AUDIO FILE SIZE IS: {YEL}";FILESIZE
  PRINT "{WHT} AUDIOFRAME SIZE IS: {GRN}";ASIZE
  PRINT "{WHT}      FRAME RATE IS: {YEL}";FPS
  PRINT "{WHT}          VERA RATE: {LIGHT GREEN}";
SKIP_AUDIOINFO:
  DRATE = ASIZE*FPS
  VERA.RATE = FN ROUND((DRATE/VERABASERATE) * VERARATEDIVISOR ) - 1
IF MESSAGES_OFF THEN SKIP.RATEPRINT
  PRINT VERA.RATE
  PRINT
  PRINT
SKIP.RATEPRINT:
  APLOOPS = 1
  IF ASIZE < 2048 THEN APLOOPS = 2
  M255 = INT(ASIZE/255)
  AREMAINDER = ASIZE - (255*M255)
  IF AREMAINDER = 0 THEN AREMAINDER = 255:M255 = M255-1
  BANK 10
  POKE R0L, APLOOPS
  POKE R0H, M255
  POKE R1L, AREMAINDER
  POKE R1H, M255
  POKE R2L, AREMAINDER
  BANK 10
  SYS $A006
RETURN

CALCULATE.SPRITES:
  SPR.DATA.SIZE = SPRHEIGHT * SPRWIDTH
  IF BPP = 4 THEN SPR.DATA.SIZE = SPR.DATA.SIZE/2
  SPR.FRAME.SIZE = SPR.DATA.SIZE * NUMSPRITES
  SPR.ATTR.ENDADDR = $FC06 + (NUMSPRITES*8*2)
  SPR.BLOCK2.DATAADDR = SPRITE.ORIG.ADDR+(SPR.FRAME.SIZE) + PALSIZE
RETURN

SET.SPRITECODE:
  SBuff255 = INT(SPR.FRAME.SIZE/255)
  SBuffRem = SPR.FRAME.SIZE - (255*SBuff255)
  IF SBuffRem = 0 THEN SBuffRem = 255:SBuff255=SBuff255 - 1
  IF MESSAGES_OFF THEN SKIPCODEMSG
  PRINT "{WHT}  FRAME SIZE: {YEL}";SPR.FRAME.SIZE
  PRINT "{WHT}        BITS:{YEL}";BPP
  PRINT
  PRINT "{WHT}    ATTR END ADDR: {LIGHT GREEN}";HEX$(SPR.ATTR.ENDADDR)
  PRINT "{WHT} BLOCK2 DATA ADDR: {LIGHT GREEN}";HEX$(SPR.BLOCK2.DATAADDR)
  PRINT
  PRINT "{WHT}        SBUFF255:{GRN}"; SBuff255
  PRINT "{WHT} SBUFF Remainder:{GRN}"; SBuffRem
  PRINT
  PRINT " {WHT}Number of Sprites:{LIGHT GREEN}";NUMSPRITES
  PRINT
SKIPCODEMSG:
  POKE R3L, SBuff255
  POKE R3H, SBuffRem
  POKE R4L, NUMSPRITES
  POKE R5L, FN Lo.Byte(SPR.ATTR.ENDADDR)
  POKE R5H, FN Hi.Byte(SPR.ATTR.ENDADDR)
  POKE R6L, FN Lo.Byte(SPR.BLOCK2.DATAADDR)
  POKE R6H, FN Hi.Byte(SPR.BLOCK2.DATAADDR)
  BANK VIDPLAYER_BANK
  IF BPP = 4 THEN SYS $A00C:RETURN
  SYS $A009
RETURN

SetUpSprites:
   SPR.DEPTH = 1
   SPR.PAL1 = 0
   SPR.PAL2 = 0
   IF BPP = 4 THEN SPR.DEPTH = 0:SPR.PAL1 = 14:SPR.PAL2=15
   IF FORCE.GRAY THEN SPR.PAL1 = 1:SPR.PAL2 = 1
   S.WIDTH = -1
   IF SPRWIDTH = 64 THEN S.WIDTH = 3
   IF SPRWIDTH = 32 THEN S.WIDTH = 2
   IF SPRWIDTH = 16 THEN S.WIDTH = 1
   IF SPRWIDTH = 8 THEN S.WIDTH = 0
   IF S.WIDTH = -1 THEN PRINT "SPRITE ERROR: ";SPRWIDTH;" WIDTH VAR":STOP
   S.HEIGHT = -1
   IF SPRHEIGHT = 64 THEN S.HEIGHT = 3
   IF SPRHEIGHT = 32 THEN S.HEIGHT = 2
   IF SPRHEIGHT = 16 THEN S.HEIGHT = 1
   IF SPRHEIGHT = 8 THEN S.HEIGHT = 0
   IF S.HEIGHT = -1 THEN PRINT "SPRITE ERROR: ";SPRHEIGHT;" HEIGHT VAR":STOP
   Y1 = Y.ORG
   X1 = X.ORG
   VADDR=SPRITE.ORIG.ADDR
   VADD.ON = (SPR.DATA.SIZE*NUMSPRITES) + PALSIZE

   FOR SPR = 1 TO NUMSPRITES
     SPRMEM SPR,SPRITE.VBANK,VADDR
     SPRMEM SPR+NUMSPRITES,SPRITE.VBANK,VADDR+VADD.ON
     VADDR = VADDR + SPR.DATA.SIZE
     SPRITE SPR, 3, SPR.PAL1, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     SPRITE SPR+NUMSPRITES, 0, SPR.PAL2, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     MOVSPR SPR, X1,Y1
     MOVSPR SPR+NUMSPRITES, X1, Y1
     X1=X1+SPRWIDTH:IF X1>=X.ORG + FRAMEWIDTH THEN X1=X.ORG:Y1=Y1 + SPRHEIGHT
   NEXT
   IF BPP = 4 THEN RECT X.ORG,Y.ORG, X.ORG+(FRAMEWIDTH-1),Y.ORG+(FRAMEHEIGHT-1), 0
RETURN

BASENAME.TO.UPPER:
  L = LEN(BASENAME$)
  TMP$=""
  FOR I = 1 TO L
      C$=MID$(BASENAME$,I,1)
      C = ASC(C$)
      IF C > 96 AND C< 123 THEN C=C-32
      IF C > 192 AND C<219 THEN C=C-128
      TMP$=TMP$+CHR$(C)
  NEXT
  BASENAME$=TMP$
RETURN

GET.VIDEO.HEADER:
  IF (NOT MESSAGES_OFF) THEN PRINT " {WHT}READING: {GRN}VIDEO HEADER":PRINT
  VHEADER$ = RPT$(32,32)
  A = POINTER(VHEADER$)+1
  POKE X.REG, 4
  SYS CHKIN
  POKE A.REG, 32
  POKE X.REG, PEEK(A)
  POKE Y.REG, PEEK(A+1)
  POKE C.REG, 0
  SYS MACPTR
  SYS CLRCHN
RETURN

SET.VIDEO.ATTRIBUTES:
  ID$ = LEFT$(VHEADER$,4)
  IF ID$ <> "SPRV" THEN PRINT "BAD VIDEO FILE ID {RED}";ID$:PRINT:STOP
  VTYPE = ASC(MID$(VHEADER$,5,1))
  IF VTYPE<>1 THEN PRINT "BAD VIDEO FILE TYPE {RED}";VTYPE:PRINT:STOP
  BPP = ASC(MID$(VHEADER$,6,1))
  IF BPP<>8 AND BPP<> 4 THEN PRINT "UNSUPPORTED VIDEO FILE BPP {RED}";BPP:PRINT:STOP
  FPS = ASC(MID$(VHEADER$,7,1))
  SPRWIDTH = ASC(MID$(VHEADER$,8,1))
  SPRHEIGHT = ASC(MID$(VHEADER$,9,1))
  FRAMEWIDTH = ASC(MID$(VHEADER$,10,1)) + (256 * ASC(MID$(VHEADER$,11,1)))
  FRAMEHEIGHT = ASC(MID$(VHEADER$,12,1)) + (256 * ASC(MID$(VHEADER$,13,1)))
  NUMFRAMES = ASC(MID$(VHEADER$,14,1)) + (256 * ASC(MID$(VHEADER$,15,1))) + (65536 * ASC(MID$(VHEADER$,16,1)))
  FRAME_HINT$ = MID$(VHEADER$,18,1)
  NUMSPRITES = (FRAMEWIDTH/SPRWIDTH) * (FRAMEHEIGHT/SPRHEIGHT)
  IF MESSAGES_OFF THEN SKIP.SHOWATTRS
     PRINT "{WHT}  FRAME WIDTH: {GRN}";FRAMEWIDTH
     PRINT "{WHT} FRAME HEIGHT: {GRN}";FRAMEHEIGHT
     PRINT "{WHT} SPRITE WIDTH: {LIGHT GREEN}";SPRWIDTH
     PRINT "{WHT}SPRITE HEIGHT: {LIGHT GREEN}";SPRHEIGHT
SKIP.SHOWATTRS:
  PALSIZE = 512
  SPRITE.VBANK = 0
  SPRITE.ORIG.ADDR = 0
  IF BPP = 4 THEN PALSIZE = 0:SPRITE.VBANK = 1:SPRITE.ORIG.ADDR = $3000
RETURN

LOADMLPLAYER:
 F$="PLAYVIDEO.V3.BIN":GOSUB FILEEXISTS
 IF FE% THEN BLOAD "PLAYVIDEO.V3.BIN",8,VIDPLAYER_BANK,$A000:RETURN
 PRINT "{YEL}PLAYVIDEO.V3.BIN  {WHT}NOT FOUND {GRN}!"
 PRINT "{LIGHT GREEN}POKING THE CODE {GRN}!{YEL}.";
 ADDR = $A000
 RESTORE VIDEOPLAYERCODE
 BANK VIDPLAYER_BANK
 FOR AZ = $A000 TO $A3D5
     READ C
     POKE AZ, C
     PRINT ".";
 NEXT
 PRINT
 CLS
RETURN


VIDEOPLAYERCODE:
DATA 76,15,160,76,20,163,76,76,163,76,104,163,76,159,163,165,2,133,50,165,3,9,15,133,51,165,1,72,100,1,100,112,100,113,156,60,159,169,128,141,59,159,165,51,141,59,159,169,2,133,102,162,6
DATA 32,198,255,169,6,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68,255,198,102,208,224,169,6,133,103,32,204,255,100,32,165,50,141,60,159,32
DATA 44,161,165,112,201,0,208,81,162,6,32,198,255,173,39,159,41,8,240,249,162,61,160,159,169,255,56,32,68,255,162,61,160,159,169,255,56,32,68,255,165,112,201,0,208,43,165,50,141,60,159,169
DATA 4,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68,255,32,183,255,208,21,32,189,254,208,22,165,113,201,0,208,69,32,44,161,32,183,255,208,54
DATA 128,153,169,255,133,112,128,234,156,60,159,32,204,255,32,228,255,201,17,208,3,32,64,163,201,145,208,3,32,50,163,201,27,240,11,201,32,240,38,165,50,141,60,159,128,196,169,255,133,113
DATA 133,112,128,188,169,255,133,113,76,105,160,165,112,201,0,208,3,76,105,160,32,204,255,104,133,1,96,32,228,255,201,27,240,203,201,32,240,2,128,243,169,0,128,193,162,4,32,198,255,169,70
DATA 133,2,165,32,240,19,162,54,160,254,169,73,32,168,161,100,32,156,32,159,156,33,159,128,23,162,14,160,252,169,65,32,168,161,169,1,133,32,169,0,141,32,159,169,72,141,33,159,169,16,141
DATA 34,159,162,35,160,159,169,255,56,32,68,255,198,2,208,242,162,35,160,159,169,70,56,32,68,255,173,32,159,133,52,173,33,159,133,53,162,35,160,159,169,255,56,32,68,255,162,35,160,159,169
DATA 255,56,32,68,255,162,35,160,159,169,2,56,76,68,255,142,32,159,140,33,159,141,34,159,169,1,141,37,159,165,52,141,32,159,165,53,141,33,159,169,16,141,34,159,156,37,159,162,35,160,35,169
DATA 12,203,141,35,159,202,208,250,156,35,159,136,208,250,156,32,159,169,250,141,33,159,169,17,141,34,159,162,32,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36
DATA 159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141
DATA 35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,202,208,157,96,162,4,32,198,255,169,35,133,2,165,32,240,25,162,54,160,254,169,73,32,197
DATA 162,162,192,134,38,100,32,156,32,159,169,48,141,33,159,128,27,162,14,160,252,169,65,32,197,162,162,224,134,38,169,1,133,32,169,0,141,32,159,169,83,141,33,159,169,17,141,34,159,162,35
DATA 160,159,169,255,56,32,68,255,198,2,208,242,162,35,160,159,169,35,56,32,68,255,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,162,35,160,159,169,32,56,76,68,255,203,142,32,159
DATA 140,33,159,141,34,159,162,35,160,35,169,12,141,35,159,202,208,250,156,35,159,136,208,250,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,173,35,159,141,18,163,173,35,159,141
DATA 19,163,156,32,159,169,250,141,33,159,173,18,163,141,35,159,173,19,163,141,35,159,96,0,0,0,156,32,159,156,33,159,169,16,141,34,159,169,0,160,2,162,150,156,35,159,26,208,250,202,208,247
DATA 136,208,242,96,72,173,59,159,26,137,15,240,3,141,59,159,104,96,72,173,59,159,58,48,3,141,59,159,104,96,165,2,141,48,160,165,3,141,57,160,165,4,141,79,160,165,5,58,58,141,155,160,165
DATA 6,141,177,160,96,165,8,141,50,161,165,9,141,123,161,165,10,141,201,161,141,203,161,165,12,141,58,161,165,13,141,60,161,165,14,141,90,161,165,15,141,95,161,169,44,162,161,141,103,160
DATA 141,199,160,142,104,160,142,200,160,96,165,8,141,84,162,165,9,141,167,162,165,10,141,208,162,141,210,162,165,12,141,92,162,165,13,141,94,162,165,14,141,134,162,165,15,141,139,162,169
DATA 78,162,162,141,103,160,141,199,160,142,104,160,142,200,160,96

REM 982  BYTES CONVERTED
